--- old/usr/src/uts/common/smbsrv/smb_ktypes.h	2020-04-15 01:43:39.020557644 +0000
+++ new/usr/src/uts/common/smbsrv/smb_ktypes.h	2020-04-15 01:43:39.026291652 +0000
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2019 Nexenta by DDN, Inc. All rights reserved.
+ * Copyright 2020 RackTop Systems, Inc.
  */
 
 /*
@@ -888,6 +889,7 @@
     ASSERT(((p) != NULL) && ((p)->s_magic == SMB_SESSION_MAGIC))
 
 #define	SMB_CHALLENGE_SZ	8
+#define	SMB3_PREAUTH_HASHVAL_SZ	64
 
 typedef enum {
 	SMB_SESSION_STATE_INITIALIZED = 0,
@@ -938,6 +940,7 @@
 	struct smb_sign		signing;	/* SMB1 */
 	void			*sign_mech;	/* mechanism info */
 	void			*enc_mech;
+	void			*preauth_mech;
 
 	/* SMB2/SMB3 signing support */
 	int			(*sign_calc)(struct smb_request *,
@@ -976,6 +979,12 @@
 	uint16_t		smb_max_mpx;
 	smb_srqueue_t		*s_srqueue;
 	uint64_t		start_time;
+
+	uint16_t		smb31_enc_cipherid;
+	uint16_t		smb31_preauth_hashid;
+	uint8_t			smb31_preauth_hashval[SMB3_PREAUTH_HASHVAL_SZ];
+	uint8_t			smb31_preauth_salt[32];
+
 	unsigned char		MAC_key[44];
 	char			ip_addr_str[INET6_ADDRSTRLEN];
 	uint8_t			clnt_uuid[16];
